addHook("ThinkFrame", function()
    for player in players.iterate
        if player.spinitem
            player.spinitem = 0
        end
    end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
	 --local player = mo.player
		if not player.mo.skin == "hypermetal" then break end
        if not (player and player.valid) then break end -- player does not exist, don't run
        if not (player.realmo and player.realmo.valid) then break end -- player does not exist 2: revengence, don't run
		
		if (player.pflags & PF_SPINNING and player.speed > 15*FRACUNIT)
		or player.charability == CA_THOK and (player.pflags & PF_THOKKED and player.speed > 15*FRACUNIT) and not (player.pflags & PF_SHIELDABILITY)
		
            local traily = P_SpawnGhostMobj(player.mo)
            traily.fuse = 5
            traily.rollangle = player.mo.rollangle
            if (traily.tracer) then
                traily.tracer.fuse = 5
            end
        end
	end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate do										//You gotta be a player
		if player.fakeroll == nil
		and player.mo.skin == "hypermetal"
			player.fakeroll = 0										//make it exist
		end
		player.mo.rollangle = (player.mo.rollangle - player.fakeroll)
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do										//you gotta be a player
		if P_IsObjectOnGround(player.mo) and player.speed > 2000000
		and player.mo.skin == "hypermetal"
			player.fakeroll = ((player.mo.angle - R_PointToAngle(player.mo.x, player.mo.y)) / 2)		//The actual angle script
			if player.fakeroll > 200000000 then								//if you're going too far to the left then
				player.fakeroll = 200000000								//cap your angle
			end	
			if player.fakeroll < -200000000 then								//if you're going too far to the right then
				player.fakeroll = -200000000								//cap your angle
			end
		else													//if you're not running or you're not on the ground then
			player.fakeroll = 0										//become vertical again
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate do
		if player.mo.skin == "hypermetal"
			player.mo.rollangle = (player.mo.rollangle + player.fakeroll)
		end
	end
end)

//Enable the code below to draw some random crap (for debug reasons only)
//hud.add(function(v)
//	for player in players.iterate do
//		v.drawNum(160, 5, player.mo.rollangle, V_ORANGEMAP|V_30TRANS)
//		v.drawNum(160, 15, player.mo.angle, V_ORANGEMAP|V_30TRANS)
//		v.drawNum(160, 25, R_PointToAngle(player.mo.x, player.mo.y), V_ORANGEMAP|V_30TRANS)
//		v.drawNum(160, 35, player.speed, V_ORANGEMAP|V_30TRANS)
//	end
//end)

local function dropStart(player)
    player.isdropping = false
end

addHook("PlayerSpawn", dropStart)

local function dropThink(pl)
    if P_IsObjectOnGround(pl.mo) then
	   pl.isdropping = false
	end
end

addHook("PlayerThink", dropThink)


local function dropSpin(p)

    if skins[p.mo.skin].ability2 == CA_SPINDASH  then
	   return
	end

    if p.isdropping 
	    return 
	end
	
	P_Thrust(p.mo, p.mo.angle, 30*FRACUNIT)
	P_SetObjectMomZ(p.mo, 17*FRACUNIT)
	
	S_StartSound(p.mo, sfx_s3k3e)
    p.isdropping = true
end

addHook("JumpSpinSpecial", dropSpin)

//Sonic Lost World Bounce Attack. made by me, MotdSpork. Boing!
addHook("MobjThinker", function(sonic)
	if (sonic and sonic.skin == "hypermetal") //if you're sonic..
	and sonic.player.playerstate == PST_LIVE //you alive bruh?
	and not (sonic.player.powers[pw_super]) //super sonic has float instead
		if sonic.player.bounceattack == nil //if the variable doesnt exist
			sonic.player.bounceattack = 0 //create variable
		end
		if sonic.player.bouncenumber == nil //if the variable doesnt exist
			sonic.player.bouncenumber = 0 //create variable
			sonic.player.justchangedbouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(sonic) //are you on the ground?
		and sonic.player.bounceattack == 0 //the player isnt bouncing
			sonic.player.bouncenumber = 0 //set it to zero!
		end
		if sonic.player.usedown == nil //if the variable doesnt exist
		or not (sonic.player.cmd.buttons & BT_CUSTOM3) //not pressing the spin button?
			sonic.player.usedown = 0 //create variable
			sonic.player.justchangedbouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(sonic) //Is the player on the ground?
		and (sonic.player.cmd.buttons & BT_CUSTOM3) //Is the player holding the spin button?
			sonic.player.usedown = 1 //Set it to one!
		end
		if sonic.player.pflags & PF_JUMPED //if the player has jumped
		and not (P_IsObjectOnGround(sonic)) //and you arent on the ground.
		and sonic.player.cmd.buttons & BT_CUSTOM3 //pressing custom2?
		and sonic.player.bounceattack == 0 //checking if the custom variable it set to 0
		and sonic.player.usedown == 0 //make sure you arent holding the spin button.
		and not (sonic.player.exiting) //not...exiting the level?
		and sonic.health //you're alive?
		and not (P_PlayerInPain(sonic.player)) //not hurt are you?
			sonic.player.bounceattack = 1 //set it to one!
			P_SetObjectMomZ(sonic, -45*FRACUNIT) //make the player "shoot" downward
			//P_SetObjectMomZ(sonic, FixedMul(-55*FRACUNIT, sonic.scale)) //make the player shoot downwards 
			sonic.player.pflags = $1|PF_THOKKED //force the player into a "thokked" state
		end

		if (sonic.eflags & MFE_JUSTHITFLOOR) //you're on the ground.
		and not (sonic.player.pflags & PF_SPINNING) //you arent spinning....somehow
		and not (sonic.player.pflags & PF_STARTDASH) //you arent doing a spindash
		and not (sonic.tracer and sonic.tracer.type == MT_TUBEWAYPOINT) //not in a...zoomtube?
		and sonic.player.bounceattack == 1 //our custom variable is one right...?
		and sonic.health //is the player alive..?
		and not (P_PlayerInPain(sonic.player)) //not hurt are you?
			if sonic.player.bouncenumber == 0 //if he hasnt bounced yet
			and sonic.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
				sonic.player.justchangedbouncenumber = 1 //now he has!
				sonic.player.bouncenumber = 1 //Set this to one!
				sonic.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				P_SetObjectMomZ(sonic, 12*FRACUNIT)
				if not (sonic.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					sonic.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			if sonic.player.bouncenumber == 1 //if it's currently on his first bounce
			and sonic.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
			and not (P_PlayerInPain(sonic.player)) //not hurt are you?
				sonic.player.justchangedbouncenumber = 1 //now he has!
				sonic.player.bouncenumber = 1 //set this to two!
				sonic.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				P_SetObjectMomZ(sonic, 13*FRACUNIT)
				if not (sonic.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					sonic.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			if sonic.player.bouncenumber == 2 //if it's currently on his second bounce
			and sonic.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
			and not (P_PlayerInPain(sonic.player)) //not hurt are you?
				sonic.player.justchangedbouncenumber = 1 //now he has!
				sonic.player.bouncenumber = 0 //set it back to zero
				sonic.state = S_PLAY_SPRING //change to spring frame, like is SLW!
				P_SetObjectMomZ(sonic, 17*FRACUNIT) //send the player upwards
				sonic.player.pflags = $1 & ~PF_JUMPED // No longer jumping. Don't land on an enemy!
			end
			sonic.player.bounceattack = 0 //set it back to zero.
			sonic.player.usedown = 1 //set it to one.

			S_StartSound(sonic, sfx_s3k77) //play a sound c:			
			
		end
		//some quick checks
		
		if sonic.player.bounceattack == 1 //checking our variable.
		and sonic.health //and you're alive
		and not (P_PlayerInPain(sonic.player)) //not hurt are you?
			P_SpawnThokMobj(sonic.player) //spawn the players thok object
			if not (sonic.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
				sonic.state = S_PLAY_ROLL //force the player into a spinning state.
			end
			if (sonic.momz > (9000*P_MobjFlip(sonic))) // the player is going up...?  
				P_SetObjectMomZ(sonic, FixedMul(-55*FRACUNIT, sonic.scale)) //not anymore >.>
			end
		else 
			sonic.player.bounceattack = 0 //set it to 0
		end
		if sonic.player.bounceattack == 1 //checking if hes bouncing
			sonic.player.pflags = $1 & ~PF_SPINNING // you're no longer "spinning" if you were before
		end
		if not (sonic.player.pflags & PF_JUMPED) // if you are not actuallly jumping
			sonic.player.bounceattack = 0 //set this back to zero to be safe
		end
		
		if sonic.eflags & MFE_GOOWATER //is the player in THZ goop?
		or sonic.player.powers[pw_carry] //is the player being carried?
		//or sonic.player.pflags & PF_ROPEHANG //is the player on a ACZ ropehang?
			sonic.player.bounceattack = 0 //set to zero!
		end
		if not (sonic.player.pflags & PF_JUMPED) //if the player hasnt jumped
			sonic.player.bounceattack = 0 //set this to zero
		end
	end
end, MT_PLAYER)

local THOKSPEED = 60 * FRACUNIT
addHook("ThinkFrame", function(player)
	for player in players.iterate()
		local mo = player.mo
		if player and mo
		and mo.valid and player.playerstate == PST_LIVE
		and player.cmd.buttons & BT_CUSTOM1
		and (player.pflags & PF_JUMPED)
		and not (player.pflags & PF_THOKKED)
			P_InstaThrust(mo, mo.angle, THOKSPEED)
			player.pflags = $ | PF_THOKKED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
			mo.state = S_PLAY_ROLL

		end
	end
end)

//Walljump lua first so we can check if the player is clinging or not first
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "hypermetal")
			
			//if not (player.atwall)
				player.atwall = 0
			//end
			if not (player.cling)
				player.cling = false
			end
			if not (player.clingprev)
				player.clingprev = false
			end
			if (player.mo) //Fixes spectating, and possibly other things
				//Finding walls (not FOFs)
				local wall = R_PointInSubsector(player.mo.x+FixedMul(25*FRACUNIT, cos(player.mo.angle)), player.mo.y+FixedMul(25*FRACUNIT, sin(player.mo.angle))).sector
				local fheight = wall.floorheight
				local cheight = wall.ceilingheight

				if wall.f_slope then
					fheight = P_GetZAt(wall.f_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				if wall.c_slope then
					cheight = P_GetZAt(wall.c_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				
				if (fheight > player.mo.z) or ((cheight <= player.mo.height+player.mo.z) and not (fheight == cheight)/* and (wall.ceilingpic == "F_SKY1")*/) //This last bit seems to be broken...
					player.atwall = 1
				end
				//FOFs can be walls too, so lets check for those
				for wall in wall.ffloors()
					if (player.mo.z <= wall.topheight) and (player.mo.height+player.mo.z > wall.bottomheight)
						and(wall.flags & FF_BLOCKPLAYER) //Don't want the player to cling to water. That would be stupid
						player.atwall = $1 + 1
					end		
				end
				if(player.atwall <= 0)
					if (player.cling)
						player.pflags = $1&~PF_JUMPED
						player.mo.state = S_PLAY_FALL
					end
					player.cling = false
				end	
				if (P_IsObjectOnGround(player.mo))
					player.cling = false
				end	
				//This allows sonic to thok away from a wall. You can remove this if you dont want your character to do this.
				//Lazy checks
				if (player.powers[pw_carry] == CR_NONE) 
				and not (player.charability2 == CA2_MULTIABILITY)
					//If you're clinging to a wall
					if (player.cling)
						and not (player.cmd.buttons & BT_JUMP)
						if (player.powers[pw_underwater])
							P_SetObjectMomZ(player.mo, 25*FRACUNIT)
						else
							P_SetObjectMomZ(player.mo, 25*FRACUNIT)
						end
						S_StartSound(player.mo, sfx_s3k77)
						player.cling = false
						if (player.charability2 == CA2_SPINDASH)
							player.mo.state = S_PLAY_ROLL //L
						else
							player.mo.state = S_PLAY_SPRING //P
						end
						player.jumping = false
						P_InstaThrust(player.mo, player.mo.angle, -player.actionspd/3) //Devided by 3 for sonic, but you can remove this for your character
						player.mo.angle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
					end
					//Cling onto a wall
					if (player.atwall > 0)
						and (((player.mo.momz < -3*FRACUNIT+1) and not (player.mo.flags2 & MF2_OBJECTFLIP)) or ((player.mo.momz > 3*FRACUNIT-1) and (player.mo.flags2 & MF2_OBJECTFLIP)))
						and (player.pflags & PF_JUMPED)
						and (player.cmd.buttons & BT_CUSTOM1)
						and not (player.exiting)
						P_SetObjectMomZ(player.mo, -3*FRACUNIT)
						player.mo.momx = $1 / 2
						player.mo.momy = $1 / 2
						player.mo.state = S_PLAY_ROLL //F
						player.mo.frame = 2
						player.cling = true
						if (player.clingprev == false)
							S_StartSound(player.mo,sfx_s3k4a)
						end
						if not (S_SoundPlaying(player.mo,sfx_s3k7e))
							S_StartSound(player.mo, sfx_s3k7e)
						end
					end
				end			
				//Movement fix
				if (player.cling)
					player.normalspeed = 5
				else 
					player.normalspeed = skins[player.mo.skin].normalspeed
				end
				player.clingprev = player.cling	
			end		
		end
	end
end)

//Walljump lua first so we can check if the player is clinging or not first
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "hypermetal")
			
			//if not (player.atwall)
				player.atwall = 0
			//end
			if not (player.cling)
				player.cling = false
			end
			if not (player.clingprev)
				player.clingprev = false
			end
			if (player.mo) //Fixes spectating, and possibly other things
				//Finding walls (not FOFs)
				local wall = R_PointInSubsector(player.mo.x+FixedMul(40*FRACUNIT, cos(player.mo.angle)), player.mo.y+FixedMul(40*FRACUNIT, sin(player.mo.angle))).sector
				local fheight = wall.floorheight
				local cheight = wall.ceilingheight

				if wall.f_slope then
					fheight = P_GetZAt(wall.f_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				if wall.c_slope then
					cheight = P_GetZAt(wall.c_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				
				if (fheight > player.mo.z) or ((cheight <= player.mo.height+player.mo.z) and not (fheight == cheight)/* and (wall.ceilingpic == "F_SKY1")*/) //This last bit seems to be broken...
					player.atwall = 1
				end
				//FOFs can be walls too, so lets check for those
				for wall in wall.ffloors()
					if (player.mo.z <= wall.topheight) and (player.mo.height+player.mo.z > wall.bottomheight)
						and(wall.flags & FF_BLOCKPLAYER) //Don't want the player to cling to water. That would be stupid
						player.atwall = $1 + 1
					end		
				end
				if(player.atwall <= 0)
					if (player.cling)
						player.pflags = $1&~PF_JUMPED
						player.mo.state = S_PLAY_FALL
					end
					player.cling = false
				end	
				if (P_IsObjectOnGround(player.mo))
					player.cling = false
				end	
				//This allows sonic to thok away from a wall. You can remove this if you dont want your character to do this.
				//Lazy checks
				if (player.powers[pw_carry] == CR_NONE) 
				and not (player.charability2 == CA2_MULTIABILITY)
					//If you're clinging to a wall
					if (player.cling)
						and not (player.cmd.buttons & BT_JUMP)
						if (player.powers[pw_underwater])
							P_SetObjectMomZ(player.mo, 20*FRACUNIT)
						else
							P_SetObjectMomZ(player.mo, 20*FRACUNIT)
						end
						S_StartSound(player.mo, sfx_jump)
						player.cling = false
						if (player.charability2 == CA2_SPINDASH)
							player.mo.state = S_PLAY_ROLL //L
						else
							player.mo.state = S_PLAY_SPRING //P
						end
						player.jumping = false
						P_InstaThrust(player.mo, player.mo.angle, player.actionspd/3) //Devided by 3 for sonic, but you can remove this for your character
						player.mo.angle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
					end
					//Cling onto a wall
					if (player.atwall > 0)
						and (((player.mo.momz < -3*FRACUNIT+1) and not (player.mo.flags2 & MF2_OBJECTFLIP)) or ((player.mo.momz > 3*FRACUNIT-1) and (player.mo.flags2 & MF2_OBJECTFLIP)))
						and (player.pflags & PF_JUMPED)
						and (player.cmd.buttons & BT_TOSSFLAG)
						and not (player.exiting)
						P_SetObjectMomZ(player.mo, -3*FRACUNIT)
						player.mo.momx = $1 / 2
						player.mo.momy = $1 / 2
						player.mo.state = S_PLAY_ROLL //F
						player.mo.frame = 2
						player.cling = true
						if (player.clingprev == false)
							S_StartSound(player.mo,sfx_s3k4a)
						end
						if not (S_SoundPlaying(player.mo,sfx_s3k7e))
							S_StartSound(player.mo, sfx_s3k7e)
						end
					end
				end			
				//Movement fix
				if (player.cling)
					player.normalspeed = 5
				else 
					player.normalspeed = skins[player.mo.skin].normalspeed
				end
				player.clingprev = player.cling	
			end		
		end
	end
end)



local function PreventAirWalk(player)
    if (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
	and player.mo.skin == "hypermetal"
    and not player.powers[pw_carry]
        player.mo.state = S_PLAY_FALL
    end
end

local function SpinCharThink(player)
    -- Ignore if character is grounded
    if (P_IsObjectOnGround(player.mo))
	and player.mo.skin == "hypermetal"
    player.mo.ao_donecheck = false
    return
end

    PreventAirWalk(player)

    -- If spinning in the air
    if (player.pflags & PF_SPINNING)
        -- Turn off the spinning flag; this means you won't turn slowly like when rolling on ground
        player.pflags = $ & ~PF_SPINNING
        -- Use the jump state instead
        player.mo.state = S_PLAY_JUMP
        -- Enable air ability
        player.mo.ao_donecheck = true
    end

    if (player.mo.ao_donecheck and not player.mo.coyoteTime)
        player.mo.ao_donecheck = false
        RefreshAbility(player)
    end
end

local function NonSpinCharThink(player)
    -- Ignore if character is grounded
    if (P_IsObjectOnGround(player.mo))
	and player.mo.skin == "hypermetal"
        player.mo.ao_donecheck = false
        return
    end
    
    PreventAirWalk(player)
    
    if (player.mo.state == S_PLAY_SPRING)
	and player.mo.skin == "hypermetal"
        player.mo.ao_donecheck = false
    end

    if not (player.mo.ao_donecheck or player.mo.coyoteTime)
	and player.mo.skin == "hypermetal"
        player.mo.ao_donecheck = true
        RefreshAbility(player)
    end
end

local function AirOptionsThink(player)
    if player.mo.skin == "hypermetal"
		if (player.charflags & SF_NOJUMPSPIN)
			NonSpinCharThink(player)
		else
			SpinCharThink(player)
		end
	end
end

addHook("PreThinkFrame", function()
	for player in players.iterate do
		AirOptionsThink(player);
	end
end);

addHook("PlayerThink", function(player) 

	if not(player.mo) then return end 	

  if not (player.mo.skin == "hypermetal") then return end
	if (P_IsObjectOnGround(player.mo)) 
	and (player.mo.state == S_PLAY_RUN) 
	and not player.powers[pw_super]
		P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
	end
end)

local function P_RingNearby(player) -- Is a ring in range?
    local closest
	closest = NULL

	for mo in mobjs.iterate()

		if (mo.health <= 0) -- Not a valid ring
			continue
        end

		if not (mo.type == MT_RING or mo.type == MT_COIN)
			continue
        end

		if (P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),
			player.mo.z-mo.z) > 192*FRACUNIT) -- Out of range
			continue
        end

		if not P_CheckSight(player.mo, mo) -- Out of sight
			continue
        end

		if (closest and P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),
			player.mo.z-mo.z) > P_AproxDistance(P_AproxDistance(player.mo.x-closest.x,
			player.mo.y-closest.y), player.mo.z-closest.z))
			continue
        end

		-- Found a target
		closest = mo
    end

	if closest then
		return true
    end

	return false
end

local function P_LightDash(source, enemy) -- Home in on your target

	if not source.tracer
		return -- Nothing to home in on!
    end

	-- adjust direction
	local dest = source.tracer

	if not dest then
		return
    end

	-- change angle
	source.angle = R_PointToAngle2(source.x, source.y, enemy.x, enemy.y)

	-- change slope
	local dist = P_AproxDistance(P_AproxDistance(dest.x - source.x, dest.y - source.y), dest.z - source.z);

	if dist < 1
		dist = 1
    end

	source.momx = FixedMul(FixedDiv(dest.x - source.x, dist), (60*FRACUNIT))
	source.momy = FixedMul(FixedDiv(dest.y - source.y, dist), (60*FRACUNIT))
	source.momz = FixedMul(FixedDiv(dest.z - source.z, dist), (60*FRACUNIT))
end

local function P_LookForRings(player)
    local found
    player.mo.target = NULL
    player.mo.tracer = NULL

	for mo in mobjs.iterate()

		if (mo.health <= 0) then -- Not a valid ring
			continue
        end

		if not (mo.type == MT_RING or mo.type == MT_COIN)
			continue
        end

		if (P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),
			player.mo.z-mo.z) > 192*FRACUNIT) -- Out of range
			continue
        end

		if not P_CheckSight(player.mo, mo) -- Out of sight
			continue
        end

		if (player.mo.target and P_AproxDistance(P_AproxDistance(player.mo.x-mo.x,
			player.mo.y-mo.y), player.mo.z-mo.z) >
			P_AproxDistance(P_AproxDistance(player.mo.x-player.mo.target.x,
			player.mo.y-player.mo.target.y), player.mo.z-player.mo.target.z))
			continue
        end

		-- Found a target
		found = true
		player.mo.target = mo
		player.mo.tracer = mo
	end

	if found then
		P_ResetPlayer(player)
		player.mo.state = S_PLAY_FALL
		P_ResetScore(player)
		P_LightDash(player.mo, player.mo.tracer)
		return
    end
	player.mo.momx = FixedDiv(player.mo.momx,2*FRACUNIT)
	player.mo.momy = FixedDiv(player.mo.momy,2*FRACUNIT)
	player.mo.momz = FixedDiv(player.mo.momz,2*FRACUNIT)
	player.lightdash = false
end

addHook("PlayerThink", function(player)
    if (P_RingNearby(player))
	and player.mo.skin == "hypermetal"
		player.lightdashallowed = true

		if (player.cmd.buttons & BT_TOSSFLAG)
			if not player.attackdown
				player.lightdash = TICRATE;
				player.attackdown = true;
            end
		elseif not (player.cmd.buttons & BT_TOSSFLAG)
			player.attackdown = false
        end
	else
		player.lightdashallowed = false
    end

	if player.lightdash
	and player.mo.skin == "hypermetal"
		P_LookForRings(player)
		player.powers[pw_flashing] = 2
    end
end)

--Xian
--Kirb the Korb

-- Spin Dash turning modification
addHook("PlayerThink", function(player)

	--Apply only to players with the normal spindash
	if player.charability2 ~= CA2_SPINDASH
	and not player.mo.skin == "hypermetal"
		return
	end

	if (player.pflags & PF_SPINNING) 									-- Check to see if spinning
	and not (player.pflags & PF_STARTDASH) 								-- Revving the Spindash does not count
	and (P_IsObjectOnGround(player.mo))									-- Drifting only occures when on the ground
	and (player.cmd.forwardmove ~= 0) and (player.cmd.sidemove ~= 0)	-- only turn when the player wants to							
	and (player.speed > 1*FRACUNIT) then								-- minimum speed requirment


		-- Current information about the player
		local mom = FixedHypot(player.mo.momx, player.mo.momy)					-- Base Speed (No friction or drag)
		local motion = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy) 	-- base direction (No outside forces)

		-- Direction player is inputting
		local pangle = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)

		-- Calculate the new direction 
		local turn = 0
		local turning = FixedAngle(FixedMul(FixedDiv(AngleFixed(ANG2), 29*FRACUNIT/32), player.mo.friction)) -- scale by friction
		local dif = pangle - motion
		if dif > turning or dif < -turning then	-- Presision handling
			if dif > 0 then						-- Angle between 0 and 180 degrees (Left)
				turn = motion + turning	-- Turn Left
			else
				turn = motion - turning	-- Turn Right
			end
		else
			turn = pangle				--Go straight
		end

		-- Apply new movement and replace old movement
		P_InstaThrust(player.mo, turn, mom)

	end

end)

-- Scale dust made by the spindash to match how charged it is
local SpindustCheck = false
addHook("SpinSpecial", function(player)

	if not (skins[player.mo.skin].flags & SF_NOSPINDASHDUST)	-- Player's skin didn't already override the dust
	and (player.charability2 == CA2_SPINDASH)					-- Player's skin uses the Spindash
	and player.mo.skin == "hypermetal"
	and (player.pflags & PF_STARTDASH) 							-- Player is charging the spindash
	and (P_IsObjectOnGround(player.mo)) then					-- Player is on the ground

		player.charflags = $ | SF_NOSPINDASHDUST	-- Disable original spindash dust

		-- Check if player is in a liquid so that the spindash makes bubbles instead of dust
		local particleType
		if (player.mo.eflags & (MFE_TOUCHWATER | MFE_UNDERWATER)) then
			particleType = MT_SMALLBUBBLE
		else
			particleType = MT_SPINDUST
		end

		local charge = FixedDiv(player.dashspeed, player.maxdash)	-- Get a 0 - 1 percentage charge of the spindash

		if (P_RandomFixed() < charge + FU/2) then
			-- create dust particle and set its effects/scale/velocity based off of how charged the spindash is
			local dust = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-2, 2)*FU, P_RandomRange(-2, 2)*FU, 0, particleType)
			dust.momx = P_RandomRange(-2, 2) * charge
			dust.momy = P_RandomRange(-2, 2) * charge
			dust.momz = P_RandomRange( 0, 2) * charge
			P_Thrust(dust, player.mo.angle, -12 * charge)
			dust.destscale = 3 * charge / 2
		end

	end

	-- Change nothing else
	return false
end)

addHook("PlayerThink", function(p)
	local mo = p.mo
	if not (p and p.valid) return end --Check whether Player exists
	//if not onWhiteList(p, whitelist) return end --Check whether Player's skin is on the whitelist
	//if skins[mo.skin].flags & SF_NOJUMPSPIN return end --Check whether Player spins while jumping by default

	p.charflags = $|SF_NOJUMPSPIN --Disable vanilla jumpspin

	if p.pflags & PF_JUMPED
	and p.panim ~= PA_ABILITY
	and not (mo.state >= S_PLAY_SUPER_TRANS1 and mo.state <= S_PLAY_SUPER_TRANS6)
	and not (p.pflags & PF_THOKKED)
	and not (p.charability == CA_THOK and p.cmd.buttons & BT_SPIN and p.powers[pw_super])
		local apex = FixedMul(4*mo.scale, min(skins[mo.skin].jumpfactor, FRACUNIT)) --Determine jump apex,
		if mo.eflags & MFE_UNDERWATER --Correct for being underwater,
			apex = 117*$/200
		end

		if mo.momz > -apex and mo.momz < apex --while at apex of jump,
			if mo.state ~= S_PLAY_ROLL
				mo.state = S_PLAY_ROLL --Spinning animation
			end
		else

			if not (mo.eflags & MFE_VERTICALFLIP) and mo.momz > 0 --when going up,
			or mo.eflags & MFE_VERTICALFLIP and mo.momz < 0 --or down in reverse gravity,
				if mo.state ~= S_PLAY_JUMP
				and mo.state ~= S_PLAY_SPRING
					mo.state = S_PLAY_JUMP --Jumping animation
				end
			end

			if not (mo.eflags & MFE_VERTICALFLIP) and mo.momz < 0 --when going down,
			or mo.eflags & MFE_VERTICALFLIP and mo.momz > 0 --or up in reverse gravity,
				if mo.state ~= S_PLAY_FALL
					mo.state = S_PLAY_FALL --Falling animation
				end
			end
		end



	elseif p.pflags & PF_THOKKED --Set rolling animation when using a thok ability
	and not (p.prevpflags & PF_THOKKED)
	and p.panim ~= PA_ROLL
		if p.charability == CA_THOK
		or p.charability == CA_JUMPTHOK
		or p.charability == CA_HOMINGTHOK and p.homing
			mo.state = S_PLAY_ROLL
		end
	end
	p.prevpflags = p.pflags
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
	 --local player = mo.player
        if not (player and player.valid) then break end -- player does not exist, don't run
        if not (player.realmo and player.realmo.valid) then break end -- player does not exist 2: revengence, don't run
		
		if (player.pflags & PF_SPINNING and player.speed > 15*FRACUNIT)
		or player.charability == CA_THOK and (player.pflags & PF_THOKKED and player.speed > 15*FRACUNIT) and not (player.pflags & PF_SHIELDABILITY)
		or player.dashmode >= 3*TICRATE
		
            local traily = P_SpawnGhostMobj(player.mo)
            traily.fuse = 5
            traily.rollangle = player.mo.rollangle
            if (traily.tracer) then
                traily.tracer.fuse = 5
            end
        end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.skin == "hypermetal"
	and player.playerstate == PST_LIVE
		player.mo.reload = 30
		player.mo.metaltext = 10
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "hypermetal"
		and player.playerstate == PST_LIVE
			if not (player.mo.metaltext)
				player.mo.metaltext = 0
			end
			if player.mo.metaltext > 0
				player.mo.metaltext = $1 - 1
			end
			if not (player.mo.metaltext2)
				player.mo.metaltext2 = 0
			end
			if player.mo.metaltext2 > 0
				player.mo.metaltext2 = $1 - 1
			end
			if not (player.mo.metaltext3)
				player.mo.metaltext3 = 0
			end
			if player.mo.metaltext3 > 0
				player.mo.metaltext3 = $1 - 1
			end
			if not (player.mo.metaltext4)
				player.mo.metaltext4 = 0
			end
			if player.mo.metaltext4 > 0
				player.mo.metaltext4 = $1 - 1
			end
			if not (player.mo.metaltext5)
				player.mo.metaltext5 = 0
			end
			if player.mo.metaltext5 > 0
				player.mo.metaltext5 = $1 - 1
			end
			if not (player.mo.metaltext6)
				player.mo.metaltext6 = 0
			end
			if player.mo.metaltext6 > 0
				player.mo.metaltext6 = $1 - 1
			end
			if not (player.mo.metaltext7)
				player.mo.metaltext7 = 0
			end
			if player.mo.metaltext7 > 0
				player.mo.metaltext7 = $1 - 1
			end
			if not (player.mo.metaltext8)
				player.mo.metaltext8 = 0
			end
			if player.mo.metaltext8 > 0
				player.mo.metaltext8 = $1 - 1
			end
			if not (player.mo.metaltext9)
				player.mo.metaltext9 = 0
			end
			if player.mo.metaltext9 > 0
				player.mo.metaltext9 = $1 - 1
			end
			if not (player.mo.metaltext10)
				player.mo.metaltext10 = 0
			end
			if player.mo.metaltext10 > 0
				player.mo.metaltext10 = $1 - 1
			end
			if not (player.mo.metaltext11)
				player.mo.metaltext11 = 0
			end
			if player.mo.metaltext11 > 0
				player.mo.metaltext11 = $1 - 1
			end
			if player.mo.metaltext == 1
				player.mo.metaltext2 = 10
			end
			if player.mo.metaltext2 == 1
				player.mo.metaltext3 = 5
			end
			if player.mo.metaltext3 == 1
				player.mo.metaltext4 = 5
			end
			if player.mo.metaltext4 == 1
				player.mo.metaltext5 = 5
			end
			if player.mo.metaltext5 == 1
				player.mo.metaltext6 = 3*TICRATE
			end
			if player.mo.metaltext6 == 1
				player.mo.metaltext7 = 10
			end
			if player.mo.metaltext7 == 1
				player.mo.metaltext8 = 5
			end
			if player.mo.metaltext8 == 1
				player.mo.metaltext9 = 5
			end
			if player.mo.metaltext9 == 1
				player.mo.metaltext10 = 5
			end
			if player.mo.metaltext10 == 1
				player.mo.metaltext11 = 3
			end
		end
	end
end)